void addr_cast(uint32_t data, uint8_t dlina) 
{
  uint32_t mask = 0;
  if(dlina == 8) mask = 0xFFFFFFFF;
  else {
    mask  = (0x00000001 << (4 *dlina)) -1;
    }   

  adres_reg &= ~mask;
  adres_reg |= data;
}

void set_bitf( uint32_t bit_data ) 
{
  uint32_t temp2 = (*(uint32_t*)adres_reg);
  uint32_t mask  = (0x00000001 << field_len) -1;
           
    if(field_len == 32) mask = 0xFFFFFFFF;
    mask <<= field_bit;
           
    temp2 &= ~mask;
    bit_data <<= field_bit;
    // MOD 08-04-2019
    bit_data &=  mask;  
    temp2 |=  bit_data;
    (*(uint32_t*)adres_reg) = temp2;
}

void prnt_binf( uint32_t reg_data ) 
{
  Serial.print("\t");
  uint32_t tempr_l = reg_data;
        
  for( uint32_t i = 0; i < 32; i++) {  
    if(0x80000000 & reg_data)
      Serial.print("1");
    else
      Serial.print("0");
      if((i+1)%4 == 0) Serial.print(" ");
      if((i+1)%8 == 0) Serial.print("   ");  
      reg_data <<= 1;
     }
  Serial.print("\t(");      
    print_Hex(tempr_l);
  Serial.print(")\n");      
}

void prnt_out( float *array, int dlina, int coma, float divider) 
{
  Serial.print("\n\t");      
     for( uint32_t i = 0; i < dlina; i++) {
       Serial.print(array[i]/ divider, coma);       
       Serial.print("\t");    
       if ((i+1)%16 == 0) Serial.print("\n\t");
       }
  Serial.println("\n\t");
}

void prnt_out1( float *array, int dlina) 
{
  Serial.print("\n\t");      
     for( uint32_t i = 0; i < dlina; i++) {
       int32_t tempi = array[i] -32768;
       Serial.print(tempi, DEC);       
       Serial.print("\t");    
       if ((i+1)%16 == 0) Serial.print("\n\t");
       }
  Serial.println("\n\t");
}

void prnt_out2( int16_t *array, int dlina) 
{
  Serial.print("\n\t");      
  for( uint32_t i = 0; i < dlina; i++) {
    Serial.print(array[i]);       
    Serial.print("\t");    
    if ((i+1)%16 == 0) Serial.print("\n\t");
    }
  Serial.println("\n\t");
}

/*
void prnt_out2( int *array, uint32_t dlina) 
{
  Serial.print("\n\t");      
     for ( uint32_t i = 0; i < dlina; i++)
     {
       Serial.print(array[i]);       
       Serial.print("\t");    
       if ((i+1)%16 == 0) Serial.print("\n\t");
     }
  Serial.println("\n\t");
}
*/

void print_Hex(uint32_t data) 
{
  static char buffer[11];
    sprintf(buffer, "0x%08lX", data);
    Serial.print(buffer);
}

void prnt_damp( void ) 
{
  uint32_t tempr_l = 0;        
  Serial.print("\n");
  for( uint32_t i = 0; i < 0x100; i += 4) {  
    tempr_l = adres_reg + i;
    if((i)%32 == 0) Serial.print("\n");
    Serial.print("\t"); 
    uint32_t temp = (*(uint32_t*)tempr_l);
    print_Hex(temp);
   }
}



//**//
