/*
#define AHB1PERIPH_BASE       (PERIPH_BASE + 0x00020000U)
#define GPIOA_BASE            (AHB1PERIPH_BASE + 0x0000U)
#define GPIOB_BASE            (AHB1PERIPH_BASE + 0x0400U)
#define GPIOC_BASE            (AHB1PERIPH_BASE + 0x0800U)
  C-6:
  Reg: 40020808 Value:  0000 0000    0000 0000    0011 0000    0000 0000      (0x00003000)
  C-8: clock adc
  Reg: 40020808 Value:  0000 0011    0011 0001    0000 0000    0000 0000      (0x03310000)  
  B-2: cs adc
  Reg: 40020408 Value:  0000 0000    0010 0000    0010 1010    1010 0000      (0x00202AA0)
 */

void cfg_Pins1(void)
{
  GPIO_InitTypeDef GPIO_InitStruct;

  __HAL_RCC_GPIOA_CLK_ENABLE();
  __HAL_RCC_GPIOB_CLK_ENABLE();
  __HAL_RCC_GPIOC_CLK_ENABLE();

// DEBUG PINS
  // D11, 12, 13, D7, A0, A1
  GPIO_InitStruct.Pin   = GPIO_PIN_7|GPIO_PIN_6|GPIO_PIN_5|GPIO_PIN_8|GPIO_PIN_0|GPIO_PIN_1;
  GPIO_InitStruct.Mode  = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull  = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_HIGH;
  HAL_GPIO_Init(GPIOA, &GPIO_InitStruct);

  // D10
  GPIO_InitStruct.Pin   = GPIO_PIN_6; 
  HAL_GPIO_Init(GPIOB, &GPIO_InitStruct);
  
  // D3, D4, D5, D6
  GPIO_InitStruct.Pin   = GPIO_PIN_3 | GPIO_PIN_5 | GPIO_PIN_4 | GPIO_PIN_10;
  HAL_GPIO_Init(GPIOB, &GPIO_InitStruct);
}



//**//
