
#ifdef __cplusplus
    extern "C" {
#endif
    
    void DMA1_Stream4_IRQHandler(void);

#ifdef __cplusplus
    }
#endif


// tx spi-2
void DMA1_Stream4_IRQHandler(void)
{
  HAL_GPIO_WritePin(GPIOB, GPIO_PIN_3, GPIO_PIN_SET);  
  HAL_DMA_IRQHandler(&hdma_spi2_tx);
  HAL_GPIO_WritePin(GPIOB, GPIO_PIN_3, GPIO_PIN_RESET);  
}

void HAL_I2S_TxCpltCallback(I2S_HandleTypeDef *hi2s)
{
  if(flag_updt &  0x04) { // 140 microsec
    HAL_GPIO_WritePin(GPIOB, GPIO_PIN_5, GPIO_PIN_SET);  

    trans_out2();     // 2-я часть 
    flag_updt &= ~0x04; 
    
    HAL_GPIO_WritePin(GPIOB, GPIO_PIN_5, GPIO_PIN_RESET);  
    }
}

void HAL_I2S_TxHalfCpltCallback(I2S_HandleTypeDef *hi2s)
{
  if(flag_updt &  0x02) {
    HAL_GPIO_WritePin(GPIOB, GPIO_PIN_10, GPIO_PIN_SET);  
    
    trans_out1(); // 1-я часть
    flag_updt &= ~0x02; 

    HAL_GPIO_WritePin(GPIOB, GPIO_PIN_10, GPIO_PIN_RESET);  
    }
}



//**//
